"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var path_1 = __importDefault(require("path"));
// @ts-expect-error: Blob is only available in node 15.7.0 onward
var buffer_1 = require("buffer");
var Core = __importStar(require("@math-blocks/core"));
var Editor = __importStar(require("@math-blocks/editor"));
var opentype_1 = require("@math-blocks/opentype");
var enums_1 = require("../../enums");
var typeset_1 = require("../../typeset");
var stixFontData = null;
// TODO: dedupe with renderer.test.tsx
var stixFontLoader = function () { return __awaiter(void 0, void 0, void 0, function () {
    var fontPath, buffer, blob, font;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                if (stixFontData) {
                    return [2 /*return*/, stixFontData];
                }
                fontPath = path_1.default.join(__dirname, "../../../../../assets/STIX2Math.otf");
                buffer = fs_1.default.readFileSync(fontPath);
                blob = new buffer_1.Blob([buffer]);
                return [4 /*yield*/, (0, opentype_1.parse)(blob)];
            case 1:
                font = _a.sent();
                stixFontData = (0, opentype_1.getFontData)(font, "STIX2");
                return [2 /*return*/, stixFontData];
        }
    });
}); };
describe("typesetTable", function () {
    test("navigating across the bottom row should not change the content layout", function () { return __awaiter(void 0, void 0, void 0, function () {
        var glyph, node, bcRow, zipper, moveRight, fontData, fontSize, context, options, originalScene, i, state, updatedScene;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    glyph = Editor.builders.char;
                    node = Editor.builders.algebra([
                        // first row
                        [],
                        [glyph("2"), glyph("x")],
                        [],
                        [glyph("+")],
                        [glyph("5")],
                        [],
                        [glyph("=")],
                        [],
                        [glyph("1"), glyph("0")],
                        [],
                        // second row
                        [],
                        [],
                        [],
                        [glyph("\u2212")],
                        [glyph("5")],
                        [],
                        [],
                        [glyph("\u2212")],
                        [glyph("5")],
                        [],
                        // third row
                        [],
                        [glyph("2"), glyph("x")],
                        [],
                        [glyph("+")],
                        [glyph("0")],
                        [],
                        [glyph("=")],
                        [],
                        [glyph("5")],
                        [],
                    ], 10, 3);
                    bcRow = {
                        id: Core.getId(),
                        type: "bcrow",
                        left: [],
                        right: [],
                        style: {},
                    };
                    zipper = {
                        row: Editor.zrow(Core.getId(), [], [glyph("2"), glyph("x")]),
                        breadcrumbs: [
                            {
                                row: bcRow,
                                focus: Editor.nodeToFocus(node, 21),
                            },
                        ],
                    };
                    moveRight = function (state, count) {
                        var newState = state;
                        for (var i = 0; i < count; i++) {
                            newState = Editor.reducer(newState, { type: "ArrowRight" });
                        }
                        return newState;
                    };
                    return [4 /*yield*/, stixFontLoader()];
                case 1:
                    fontData = _a.sent();
                    fontSize = 60;
                    context = {
                        fontData: fontData,
                        baseFontSize: fontSize,
                        mathStyle: enums_1.MathStyle.Display,
                        renderMode: enums_1.RenderMode.Dynamic,
                        cramped: false,
                    };
                    options = { showCursor: true };
                    originalScene = (0, typeset_1.typeset)(Editor.zipperToRow(zipper), context, options);
                    // We start with 1 here because originalScene is 0
                    for (i = 1; i < 8; i++) {
                        state = moveRight(Editor.stateFromZipper(zipper), i);
                        updatedScene = (0, typeset_1.typeset)(Editor.zipperToRow(state.zipper), context, options);
                        expect(updatedScene).toEqual(originalScene);
                    }
                    return [2 /*return*/];
            }
        });
    }); });
});
