"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.typesetLimits = void 0;
var Layout = __importStar(require("../layout"));
var enums_1 = require("../enums");
var childContextForLimits = function (context) {
    var _a;
    var mathStyle = context.mathStyle;
    var childMathStyle = (_a = {},
        _a[enums_1.MathStyle.Display] = enums_1.MathStyle.Script,
        _a[enums_1.MathStyle.Text] = enums_1.MathStyle.Script,
        _a[enums_1.MathStyle.Script] = enums_1.MathStyle.ScriptScript,
        _a[enums_1.MathStyle.ScriptScript] = enums_1.MathStyle.ScriptScript,
        _a)[mathStyle];
    var childContext = __assign(__assign({}, context), { mathStyle: childMathStyle, cramped: true });
    return childContext;
};
// TODO: render as a subsup if context.mathStyle isn't MathStyle.Display
var typesetLimits = function (typesetChild, node, context, typesetNode) {
    var childContext = childContextForLimits(context);
    var lowerBox = typesetChild(0, childContext);
    var upperBox = typesetChild(1, childContext);
    if (!lowerBox) {
        throw new Error("Lower limit should always be defined");
    }
    var inner = typesetNode(node.inner, __assign(__assign({}, context), { operator: true }));
    inner.id = node.inner.id;
    inner.style = __assign(__assign({}, inner.style), { color: node.inner.style.color });
    var innerWidth = Layout.getWidth(inner);
    var width = Math.max(innerWidth, lowerBox.width || 0, (upperBox === null || upperBox === void 0 ? void 0 : upperBox.width) || 0);
    var newInner = innerWidth < width
        ? Layout.makeStaticHBox([
            Layout.makeKern((width - innerWidth) / 2),
            inner,
            Layout.makeKern((width - innerWidth) / 2),
        ], context)
        : inner;
    if (lowerBox.width < width) {
        lowerBox.shift = (width - lowerBox.width) / 2;
    }
    if (upperBox && upperBox.width < width) {
        upperBox.shift = (width - upperBox.width) / 2;
    }
    var limits = Layout.makeVBox(width, newInner, upperBox ? [Layout.makeKern(6), upperBox] : [], [Layout.makeKern(4), lowerBox], context);
    limits.id = node.id;
    limits.style = node.style;
    return limits;
};
exports.typesetLimits = typesetLimits;
