import * as Layout from "./layout";
import type { Context } from "./types";
export declare const multiplierForContext: (context: Context) => number;
export declare const fontSizeForContext: (context: Context) => number;
declare type ThresholdOptions = {
    readonly value: "both" | "sum";
    readonly strict: boolean;
};
/**
 * Returns the smallest delimiter whose depth and height exceed the that of the
 * box passed in.  `thresholdOptions` controls how this comparison is made.
 *
 * @param {string} char
 * @param {Layout.Box} box layout encompassed by the delimiter
 * @param {ThresholdOptions} options
 * @param {Context} context
 * @returns {Layout.Glyph}
 */
export declare const makeDelimiter: (char: string, box: Layout.HBox | Layout.VBox, thresholdOptions: ThresholdOptions, context: Context) => Layout.Glyph;
export {};
